// Global Vue components
VueView.component('field-pageUrl', 'pages:assets/vue-components/field-page-url.js');
VueView.component('field-seo', 'pages:assets/vue-components/field-seo.js');
VueView.component('field-collectionpageitems', 'pages:assets/vue-components/field-collectionpageitems.js');


// add page selector to tinymce link dialog
App.on('field-wysiwyg-setup', evt => {

    let editor = evt.params[0];

    editor.on('OpenWindow', (evt) => {

        if (!evt.dialog) return;

        let dialog = evt.dialog;
        let data = dialog.getData();

        if (!data.url || typeof(data.url.value) != 'string') {
            return;
        }

        let input = document.querySelector('.tox-dialog__body .tox-control-wrap input[type="url"]');

        if (!input) {
            return;
        }

        let link = document.createElement('a');

        link.innerText = 'Link Page'
        link.style = 'margin-top:5px;font-size:12px;';

        link.onclick = () => {

            let ele = VueView.ui.offcanvas('pages:assets/dialogs/page-picker.js', {}, {

                select: (page, locale) => {

                    data = dialog.getData();
                    data.url.value = `pages://${page._id}`+((locale && locale != 'default' && `?locale=${locale}`) || '');
                    dialog.setData(data);
                }

            }, {flip: true, size: 'large', zIndex: 1400});

            const tox = document.querySelector('.tox.tox-tinymce-aux');

            if (tox) {

                const toxZIndex = getComputedStyle(tox).zIndex;

                if (toxZIndex == 'auto') return;

                setTimeout(() => {

                    const eleZIndex = getComputedStyle(ele).zIndex;

                    if (Number(toxZIndex) > Number(eleZIndex)) {
                        ele.style.zIndex = `${Number(toxZIndex) + 1}`
                    }

                }, 150);
            }


        };

        input.after(link);
    });
});
